//! Implementation of the Reliable, Ordered, Bytestream transmission model
//! AKA: TCP-like

use crate::{
    connection::stream::{Chunk, Error, Sequence},
    enc::Random,
};

/// Reliable, Ordered, Bytestream stream tracker
/// AKA: TCP-like
#[derive(Debug, Clone)]
pub(crate) struct ReliableOrderedBytestream {
    window_start: Sequence,
    window_len: usize,
    data: Vec<u8>,
}

impl ReliableOrderedBytestream {
    pub(crate) fn new(rand: &Random) -> Self {
        Self {
            window_start: Sequence::new(rand),
            window_len: 1048576, // 1MB. should be enough for anybody. (lol)
            data: Vec::new(),
        }
    }
    pub(crate) fn recv(&mut self, chunk: Chunk) -> Result<(), Error> {
        todo!()
    }
}
